import warnings


class BaseConfig(object):

    # name
    env = 'test'
    checkpoint_path = './checkpoints'
    mode = 'regression'

    # filelist
    img_list = None
    gt_list = None

    # data stats path
    dataset = 'BaseDataset'
    train_val_split = True 
    train_ratio = 0.8

    # network 
    inchannel = 4
    num_classes = 1

    custom_model = False
    model = 'Unet'
    encoder_name = 'resnet34'
    encoder_weights = None
    encoder_weights_offline = None
    encoder_weights_offline_path = None
    encoder_depth = 4
    encoder_dilation = False
    encoder_output_stride = 16

    decoder_use_batchnorm = True
    decoder_channels = (256, 128, 64, 32)
    decoder_attention_type = 'scse'
    decoder_pyramid_channels = 256
    decoder_segmentation_channels = 128
    decoder_merge_policy = 'add'
    decoder_atrous_rates = (12, 24, 36)
    decoder_dropout = 0.2
    decoder_pab_channels = 64
    psp_out_channels = 512
    psp_use_batchnorm = True

    # augmentation
    crop_size = 256
    optical_distortion = False

    # data error 
    retry = 20
    retry_mode = 'random'

    # gpus
    use_gpu = True
    batch_size = 16
    num_workers = 8

    # criterion and loss
    criterion = 'SmoothL1Loss'
    criterion_weight = None

    # learning rate
    max_epoch = 1000
    lr = 1e-5
    weight_decay = 1e-4
    momentum = 0.9
    optimizer = 'Adam'

def parse(self, kwargs):
    for k, v in kwargs.items():
        if not hasattr(self, k):
            warnings.warn('Warnings: opt has not attribute %s' % k)
        if k == 'custom_config':
            continue
        setattr(self, k, v)


BaseConfig.parse = parse
base_cfg = BaseConfig()